#ifndef TJSONVALUE_H
#define TJSONVALUE_H

#include	<vector>
#include	<map>
#include	<utility>
#include	<string>

class TJsonValue {
public:
	// ľ^
	enum ValueType {
		UNKNOWN_TYPE,	// s
		VALUE,	// l
		ARRAY,	// z
		OBJECT	// IuWFNg
	};

	// l̃Tu^Cv
	enum ValueSubType {
		UNKNOWN_SUB_TYPE,	// s
		STRING,		// 
		NUMBER		// l
	};

private:
	ValueType type;
	ValueSubType subType;

	std::vector<TJsonValue *> arrayValue;
	std::map<std::string,TJsonValue *> objectValueMap;
	char *value;

public:

	TJsonValue();
	virtual ~TJsonValue();

	ValueType getType(void)
	{
		return type;
	}

	ValueType setType(ValueType newType)
	{
		type = newType;
		return type;
	}

	ValueSubType getSubType(void)
	{
		return subType;
	}

	ValueSubType setSubType(ValueSubType newSubType)
	{
		subType = newSubType;

		return subType;
	}

	char *getValue(void)
	{
		return value;
	}
	void setValue(const char *newValue);

	TJsonValue *addArrayValue(void);
	unsigned int getArrayCount(void)
	{
		return arrayValue.size();
	}
	TJsonValue *getArrayValue(unsigned int no)
	{
		return arrayValue[no];
	}

	TJsonValue *addObjectValue(std::string key);
	TJsonValue *getObjectValue(std::string key);
	TJsonValue *getObjectValue(int index);
	std::string getObjectKey(int index);

	unsigned int getObjectCount(void)
	{
		return objectValueMap.size();
	}
};

typedef std::pair<std::string,TJsonValue *> object_value;
typedef std::map<std::string,TJsonValue *> OBJECT_MAP;

#endif
