#include "stdafx.h"
#include "shellapi.h"

#include "BookSyncApp.h"
#include "PriorityDlg.h"

/**
 * RXgN^
 *
 * @param parent eEChEnh
 * @param resource _CAO\[Xԍ
 */
CPriorityDlg::CPriorityDlg(HWND parent, int resource) : BaseDialog(parent, resource)
{
	m_bookmarkList = NULL;
	for (int i = 0; i < ALL_BOOKMARKS; i++) {
		currentPriority[i] = i;
	}
	priority = NULL;
}

/**
 * fXgN^
 */
CPriorityDlg::~CPriorityDlg()
{
	if (m_bookmarkList != NULL) {
		delete m_bookmarkList;
	}
}


/**
 * _CAO
 *
 * @return tH[JX̐ݒ肪(FALSE:)
 */
INT_PTR CPriorityDlg::OnInitDialog()
{
	m_bookmarkList = new TwrListbox(::GetDlgItem(hWnd, IDC_BOOKMARK_LIST));

	// ʂɍ܂ł̗Dx𔽉fB
	for (int i = 0; i < ALL_BOOKMARKS; i++) {
		currentPriority[i] = priority[i];
		m_bookmarkList->addItem(bookmark_name[currentPriority[i]]);
	}
	SetFocus(m_bookmarkList->getHwnd());

	return (INT_PTR)FALSE;
}

/**
 * WM_COMMANDbZ[W̏
 *
 * @param wParam WPARAM
 */
INT_PTR CPriorityDlg::OnCommand(WPARAM wParam)
{
	switch (LOWORD(wParam)) {
		case IDC_UP_PRI_BUTTON:
			OnBnClickedUpPriButton();

			return (INT_PTR)TRUE;
		case IDC_DOWN_PRI_BUTTON:
			OnBnClickedDownPriButton();

			return (INT_PTR)TRUE;
		case IDOK:
			OnBnClickedOk();

			break;
	}
	return BaseDialog::OnCommand(wParam);

}


/**
 * {^Ƃ̓
 */
void CPriorityDlg::OnBnClickedUpPriButton()
{
	int selected = m_bookmarkList->getSelectedIndex();
	if (selected == -1) {
		return;
	}

	if (selected == 0) {
		return;
	}
	m_bookmarkList->removeItem(selected - 1);
	m_bookmarkList->insertItem(selected,bookmark_name[currentPriority[selected - 1]]);

	int tmp = currentPriority[selected - 1];
	currentPriority[selected - 1] = currentPriority[selected];
	currentPriority[selected] = tmp;
	m_bookmarkList->selectItem(selected - 1);
}

/**
 * {^Ƃ̓
 */
void CPriorityDlg::OnBnClickedDownPriButton()
{
	int selected = m_bookmarkList->getSelectedIndex();
	if (selected == -1) {
		return;
	}

	if (selected >= (ALL_BOOKMARKS - 1)) {
		return;
	}
	m_bookmarkList->removeItem(selected);
	m_bookmarkList->insertItem(selected + 1,bookmark_name[currentPriority[selected]]);

	int tmp = currentPriority[selected + 1];
	currentPriority[selected + 1] = currentPriority[selected];
	currentPriority[selected] = tmp;
	m_bookmarkList->selectItem(selected + 1);

}

/**
 * OK{^Ƃ̓
 */
void CPriorityDlg::OnBnClickedOk()
{
	// D揇ʂ𔽉fB
	if (priority != NULL) {
		for (int i = 0;i < ALL_BOOKMARKS;i++) {
			priority[i] = currentPriority[i];
		}
	}
}
